/**
 * TCS Dependency Map Renderer
 *
 * Copyright (c) 2005 TopCoder, Inc. All rights Reserved.
 */
package com.topcoder.rules.dependencymap.view;

import java.io.File;

import junit.framework.TestCase;

/**
 * This is some basic framework code to test the basic altered
 * functionality for simple accuracy.  Additional tests are failure
 * only.
 * 
 * @author AdamSelene
 */
public class AdamSeleneUnitTest extends TestCase 
{
	
    /**
     * FixedGridLayoutManager instance to test.
     */
    private FixedGridLayoutManager manager = null;

    /**
     * ShapeFactory instance to use.
     */
    private ShapeFactory factory = null;

    /**
     * RendererGraphics to use.
     */
    private RendererGraphics graphics = null;
  
	private String filename = "test_files/failuretests/failuretest-";
	private String raFilename = "test_files/failuretests/renderAll";
	private String s1Filename = "test_files/failuretests/supress";
	private String s2Filename = "test_files/failuretests/supress2";
	
    	
    /**
     * This test was run multiple times with different arguments depending on the number of
     * enhancements to each component, to aid in the review process.
     */ 
    public void testRender_Simple() throws RendererException 
    {
        Dependency head = new Dependency("A");
        Dependency left = new Dependency("B");
        Dependency right = new Dependency("C");
        Dependency shared = new Dependency("D");
        left.addDependant(shared);
        right.addDependant(shared);
        head.addDependant(left);
        head.addDependant(right);
                      
        DiagramRenderer dg = new SVGRenderer(new File(raFilename));
        DependencyRenderer dr = new DependencyRenderer();
        dr.addDiagramRenderer(dg);
        dr.renderAll(head);
        //manager.layout(head, factory, new SVGRenderer(new File(raFilename)));
        //graphics.complete();	
    } 
    
    	
    /**
     * This test was run multiple times with different arguments depending on the number of
     * enhancements to each component, to aid in the review process.
     */ 
    public void testRender_Simple2() throws RendererException 
    {
        Dependency head = new Dependency("A");
        Dependency left = new Dependency("B");
        Dependency right = new Dependency("C");
        Dependency shared = new Dependency("D");
        left.addDependant(shared);
        right.addDependant(shared);
        head.addDependant(left);
        head.addDependant(right);
                      
        DiagramRenderer dg = new SVGRenderer(new File(raFilename));
        DependencyRenderer dr = new DependencyRenderer();
        dr.addDiagramRenderer(dg);
        dr.renderAll(head);
        //manager.layout(head, factory, new SVGRenderer(new File(raFilename)));
        //graphics.complete();	
    } 
    
    	
    /**
     * This test was run multiple times with different arguments depending on the number of
     * enhancements to each component, to aid in the review process.
     */ 
    public void testRender_Simple3() throws RendererException 
    {        
        Dependency a = new Dependency("a");
        Dependency b = new Dependency("b");
        Dependency c = new Dependency("c");
        Dependency d = new Dependency("d");
        Dependency e = new Dependency("e");
        Dependency f = new Dependency("f");
        Dependency g = new Dependency("g");
        Dependency h = new Dependency("h");
        Dependency i = new Dependency("i");
        Dependency j = new Dependency("j");
        Dependency k = new Dependency("k");
        Dependency l = new Dependency("l");
        Dependency m = new Dependency("m");
        Dependency n = new Dependency("n");
        Dependency o = new Dependency("o");
        Dependency p = new Dependency("p");
    
        m.addDependant(n);
        m.addDependant(o);
        m.addDependant(p);

        c.addDependant(d);
        c.addDependant(e);

        b.addDependant(c);
        b.addDependant(f);
        b.addDependant(g);
        b.addDependant(h);

        i.addDependant(j);
        i.addDependant(k);
        i.addDependant(l);
        i.addDependant(m);

        a.addDependant(b);
        a.addDependant(i);

        DiagramRenderer dg = new SVGRenderer(new File(s1Filename));
        DependencyRenderer dr = new DependencyRenderer();
        dr.addDiagramRenderer(dg);
        dr.renderAll(a);
    }      
	
    /**
     * This test was run multiple times with different arguments depending on the number of
     * enhancements to each component, to aid in the review process.
     */ 
    public void testRenderAll3() throws RendererException
    {
        Dependency a = new Dependency("a");
        Dependency b = new Dependency("b");
        Dependency c = new Dependency("c");
        Dependency d = new Dependency("k");
        Dependency e = new Dependency("e");
        Dependency f = new Dependency("f");
        Dependency g = new Dependency("g");
        Dependency h = new Dependency("h");
        Dependency i = new Dependency("i");
        Dependency j = new Dependency("j");
        Dependency k = new Dependency("d");

        e.addDependant(f);
        e.addDependant(g);

        d.addDependant(e);
        d.addDependant(h);
        d.addDependant(i);
        d.addDependant(j);

        b.addDependant(c);
        b.addDependant(d);
        b.addDependant(k);
        a.addDependant(b);

        DiagramRenderer dg = new SVGRenderer(new File(s2Filename));
        DependencyRenderer dr = new DependencyRenderer();
        dr.addDiagramRenderer(dg);
        dr.renderAll(a);
    }

}
