/**
 * TCS Dependency Map Renderer
 *
 * Copyright (c) 2005 TopCoder, Inc. All rights Reserved.
 */
package com.topcoder.rules.dependencymap.view;

import java.io.File;

import junit.framework.TestCase;

/**
 * This is some basic framework code to test the basic altered
 * functionality for simple accuracy.  Additional tests are failure
 * only.
 * 
 * @author AdamSelene
 */
public class AdamSeleneUnitTest extends TestCase 
{
	
    /**
     * FixedGridLayoutManager instance to test.
     */
    private FixedGridLayoutManager manager = null;

    /**
     * ShapeFactory instance to use.
     */
    private ShapeFactory factory = null;

    /**
     * RendererGraphics to use.
     */
    private RendererGraphics graphics = null;
  
	private String filename = "test_files/failuretests/failuretest-";
	private String raFilename = "test_files/failuretests/renderAll";
	
    /**
     * This test was run multiple times with different arguments depending on the number of
     * enhancements to each component, to aid in the review process.
     */ 
    public void testRender_Simple() throws RendererException 
    {
        Dependency head = new Dependency("A");
        Dependency left = new Dependency("B");
        Dependency right = new Dependency("C");
        Dependency shared = new Dependency("D");
        left.addDependant(shared);
        right.addDependant(shared);
        head.addDependant(left);
        head.addDependant(right);
                      
        DiagramRenderer dg = new SVGRenderer(new File(raFilename));
        DependencyRenderer dr = new DependencyRenderer();
        dr.addDiagramRenderer(dg);
        dr.renderAll(head);
        //manager.layout(head, factory, new SVGRenderer(new File(raFilename)));
        //graphics.complete();	
    } 
}
